<?php

	include_once 'common.php';

	function check_target($src, $dst){
		global $COL;

		if (
			$src[ $COL['SKILL1'] ] == $dst['id1'] and
			$src[ $COL['VALUE1'] ] == $dst['val1'] and
			$src[ $COL['SKILL2'] ] == $dst['id2'] and
			$src[ $COL['VALUE2'] ] == $dst['val2']
		){
			return TRUE;
		}
		else {
			return FALSE;
		}

	}

	function check_target_all(&$finds, $haystack, $data, $line_num, $needles, $depth){
		global $COL, $sheet2table;

		$depth++;
		$sheet = $data[ $COL['SHEET'] ];

		if (count($needles) <= $depth){
			$finds[$sheet2table[$sheet]] = '';
			return;
		}
		else {
			$start_num = ($sheet -1) * 5400;
			$add_num = ($data[ $COL['USE'] ] + $line_num) % 5400;
			$new_num = $start_num + $add_num;
			$cols = explode(',', $haystack[$new_num]);

			if (check_target($cols, $needles[$depth])){
				check_target_all($finds, $haystack, $cols, $new_num, $needles, $depth);
			}

		}
	}

	$target_max = 4;
	$target_min = 2;

	$results = array();
	$messages = array();
	$errors = array();
	$check = array();
	$mode = 'all';
	$result_header = '';

	if (array_key_exists('exec', $_POST)){

		// ͒l̃`FbNƐ`
		for ($i = 0; $i < $target_max; $i++){
			if (
				$_POST['skl_id'. $i. '_1'] and $_POST['skl_val'. $i. '_1'] and 
				(
					($_POST['skl_id'. $i. '_2'] and $_POST['skl_val'. $i. '_2']) or
					(!$_POST['skl_id'. $i. '_2'] and !$_POST['skl_val'. $i. '_2'])
				)
			){
				$check[$i]['id1']  = $_POST['skl_id'. $i. '_1'];
				$check[$i]['val1'] = $_POST['skl_val'. $i. '_1'];
				$check[$i]['id2']  = $_POST['skl_id'. $i. '_2'];
				$check[$i]['val2'] = $_POST['skl_val'. $i. '_2'];
			}
			elseif (
				!$_POST['skl_id'. $i. '_1'] and !$_POST['skl_val'. $i. '_1'] and 
				!$_POST['skl_id'. $i. '_2'] and !$_POST['skl_val'. $i. '_2']
			){
				break;
			}
			else {
				$errors[] = ''. ($i + 1). '̓͂sł';
				break;
			}
		}

		$check_max = count($check);
		if ($check_max == 0) {
			$errors[] = 'Lȓ͂܂';
		}

		if (count($errors) == 0){
			if (!array_key_exists($_POST['type'], $OMA_TYPES)){
				$errors[] = 'ނ̑Isł';
			}
		}

		if (count($errors) == 0){
			if (strpos($_POST['exec'], 'Ӓ茋ʏ') === 0){
				$mode = 'order';
				$result_header = '';
				if ($check_max < $target_min){
					$errors[] = "{$target_min}ȏ̓͂Kvł";
				}
			}
		}

		if (count($errors) == 0){

			$file = $_POST['type']. $FILE_EXT;

			// 胊Xgǂݍ
			$all = file_get_contents($file);
			$lines = preg_split("/[\r\n]+/", $all);
			array_shift($lines);

			if ($mode == 'order'){

				// o͌ʏ
				foreach ($tables as $table){
					$results[0][$table] = '|';
				}

				for ($i = 0; $i< count($lines); $i++){
					$cols = explode(',', $lines[$i]);

					if (check_target($cols, $check[0])){
						check_target_all($results[0], $lines, $cols, $i, $check, 0);
					}
				}

			}
			else {

				// o͌ʏ
				for ($i = 0; $i < $check_max; $i++){
					foreach ($tables as $table){
						$results[$i][$table] = '|';
					}
				}

				foreach ($lines as $line){
					for ($i = 0; $i < $check_max; $i++){
						$cols = explode(',', $line);

						if (check_target($cols, $check[$i])){
							$tbl = $sheet2table[ $cols[ $COL['SHEET'] ] ];
							$results[$i][$tbl] = '';
						}
					}
				}
			}


		}
	}

?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS">
<title>e[u</title>
</head>
<body>
<form method="post" action="table.php">
e[u<br>
<hr>
莝ɂ΂ANGXgI̊Ӓ茋ʏɌ΂͂邱ƂŁA<br>
Z[uf[^ŒƎvAue[uv邱Ƃo܂B<br>
<hr>
̎ނƃXbgɊւẮA͂sSȂߎwsɂĂ܂B<br>
Ƃ͂XL12ĊSł͂܂BЂƂ̖ڈxɂlB<br>
<hr>
<?php
	if (count($errors) > 0){
		echo '<font color="red">';

		foreach ($errors as $error){
			echo "$error<br>\n";
		}

		echo "</font><hr>\n";

	}
?>
Ώ : 
<select name="type">
<option value="">ޑI</option>
<?php
	foreach ($OMA_TYPES as $type => $name){
		$selected = ($type == $_POST['type'])? ' selected': '';
		echo "<option value=\"$type\"$selected>$name</option>\n";
	}

?>
</select>

<br>
<?php
	for ($i = 0; $i < $target_max; $i++){
		echo '', ($i+1), ' : ', <<<EOM
<!--
<select name="type$i">
</select>
-->
EOM;
		for ($j = 1; $j <= 2; $j++){
			echo '<select name="skl_id', $i, '_', $j, '">', "\n";
			echo '<option value="" selected>XL', $j, '</option>';

			include 'opt_skl.html';
			echo "</select>\n";

			echo '<select name="skl_val', $i, '_', $j, '">', "\n";
			include "opt_val{$j}.html";
			echo "</select>\n";
		}
		echo <<<EOM
<!--
<select name="slot{$i}">
</select>
-->
<br>
EOM;
	}
?>

<input type="submit" name="exec" value="莝̌΂画" />
 or 
<input type="submit" name="exec" value="Ӓ茋ʏ画" />
</form>
<hr>
<?php
	if (count($errors) == 0 and count($check) > 0){
		echo '<font color="blue">';

		for ($i = 0; $i < count($check); $i++){
			echo 'l'. ($i+1). " : ". $check[$i]['id1']. $check[$i]['val1']. $check[$i]['id2']. $check[$i]['val2'].  "<br>\n";
		}

		echo "</font><hr>\n";

	}
?>
<table border="1">
<tbody>
<tr>
<th>e[u</th>
<?php
	foreach ($tables as $table){
		echo "<th>T$table</th>\n";
	}

	echo "</tr>\n";

	for ($i = 0; $i < count($results); $i++){
		echo "<tr>\n<td>". $result_header. ($i+1). "</td>\n";
		
		foreach ($results[$i] as $result){
			echo "<td>$result</td>\n";
		}

		echo "</tr>\n";
	}
?>


</tbody>
</table>

<hr>
<a href="./" accesskey="#">[#]߂</a><br>
<hr>
<!--ANZXJE^-->
<a href="http://w1.ax.xrea.com/c.f?id=100141239-3g_xxx" target="_blank"><img src="http://w1.ax.xrea.com/l.f?id=100141239-3g_xxx&url=X" alt="AX" border="0"></a>
</body>
</html>
